Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.xensource.xenapi
Class VM.Record

    java.lang.Object
      com.xensource.xenapi.VM.Record

All Implemented Interfaces:
  Types.Record

Enclosing class:
  VM

    public static class VM.Record

extends Object
implements Types.Record

Represents all the fields in a VM

Field Summary
`Types.OnCrashBehaviour` | `actionsAfterCrash` action to take if the guest crashes
`Types.OnNormalExit` | `actionsAfterReboot` action to take after the guest has rebooted itself
`Types.OnNormalExit` | `actionsAfterShutdown` action to take after the guest has shutdown itself
`Host` | `affinity` a host which the VM has some affinity for (or NULL).
`Set<Types.VmOperations>` | `allowedOperations` list of the operations allowed in this state.
`VMAppliance` | `appliance` the appliance to which this VM belongs
`Set<PCI>` | `attachedPCIs` Currently passed-through PCI devices
`Map<String,String>` | `biosStrings` BIOS strings
`Map<String,Blob>` | `blobs` Binary blobs associated with this VM
`Map<Types.VmOperations,String>` | `blockedOperations` List of operations which have been explicitly blocked and an error code
`Set<VM>` | `children` List pointing to all the children of this VM
`Set<Console>` | `consoles` virtual console devices
`Set<Crashdump>` | `crashDumps` crash dumps associated with this VM
`Map<String,Types.VmOperations>` | `currentOperations` links each of the running tasks using this object (by reference) to a current_operation enum which describes the nature of the task.
`String` | `domarch` Domain architecture (if available, null string otherwise)
`Long` | `domid` domain ID (if available, -1 otherwise)
`String` | `generationId` Generation ID of the VM
`VMGuestMetrics` | `guestMetrics` metrics associated with the running guest
`Boolean` | `haAlwaysRun` if true then the system will attempt to keep the VM running as much as possible.
`String` | `haRestartPriority` has possible values: "best-effort" meaning "try to restart this VM if possible but don't consider the Pool to be overcommitted if this is not possible"; "restart" meaning "this VM should be restarted"; "" meaning "do not try to restart this VM"
`Map<String,String>` | `HVMBootParams` HVM boot params
`String` | `HVMBootPolicy` HVM boot policy
`Double` | `HVMShadowMultiplier` multiplier applied to the amount of shadow that will be made available to the guest
`Boolean` | `isASnapshot` true if this is a snapshot.
`Boolean` | `isATemplate` true if this is a template.
`Boolean` | `isControlDomain` true if this is a control domain (domain 0 or a driver domain)
`Boolean` | `isSnapshotFromVmpp` true if this snapshot was created by the protection policy
`Map<String,String>` | `lastBootCPUFlags` describes the CPU flags on which the VM was last booted
`String` | `lastBootedRecord` marshalled value containing VM record at time of last boot, updated dynamically to reflect the runtime state of the domain
`Long` | `memoryDynamicMax` Dynamic maximum (bytes)
`Long` | `memoryDynamicMin` Dynamic minimum (bytes)
`Long` | `memoryOverhead` Virtualization memory overhead (bytes).
`Long` | `memoryStaticMax` Statically-set (i.e.
`Long` | `memoryStaticMin` Statically-set (i.e.
`Long` | `memoryTarget` Dynamically-set memory target (bytes).
`VMMetrics` | `metrics` metrics associated with this VM
`String` | `nameDescription` a notes field containing human-readable description
`String` | `nameLabel` a human-readable name
`Long` | `order` The point in the startup or shutdown sequence at which this VM will be started
`Map<String,String>` | `otherConfig` additional configuration
`VM` | `parent` Ref pointing to the parent of this VM
`String` | `PCIBus` PCI bus path for pass-through devices
`Map<String,String>` | `platform` platform-specific configuration
`Types.VmPowerState` | `powerState` Current power state of the machine
`VMPP` | `protectionPolicy` Ref pointing to a protection policy for this VM
`String` | `PVArgs` kernel command-line arguments
`String` | `PVBootloader` name of or path to bootloader
`String` | `PVBootloaderArgs` miscellaneous arguments for the bootloader
`String` | `PVKernel` path to the kernel
`String` | `PVLegacyArgs` to make Zurich guests boot
`String` | `PVRamdisk` path to the initrd
`String` | `recommendations` An XML specification of recommended values and ranges for properties of this VM
`Host` | `residentOn` the host the VM is currently resident on
`Long` | `shutdownDelay` The delay to wait before proceeding to the next order in the shutdown sequence (seconds)
`Map<String,String>` | `snapshotInfo` Human-readable information concerning this snapshot
`String` | `snapshotMetadata` Encoded information about the VM's metadata this is a snapshot of
`VM` | `snapshotOf` Ref pointing to the VM this snapshot is of.
`Set<VM>` | `snapshots` List pointing to all the VM snapshots.
`Date` | `snapshotTime` Date/time when this snapshot was created.
`Long` | `startDelay` The delay to wait before proceeding to the next order in the startup sequence (seconds)
`SR` | `suspendSR` The SR on which a suspend image is stored
`VDI` | `suspendVDI` The VDI that a suspend image is stored on.
`Set<String>` | `tags` user-specified tags for categorization purposes
`String` | `transportableSnapshotId` Transportable ID of the snapshot VM
`Long` | `userVersion` a user version number for this machine
`String` | `uuid` Unique identifier/object reference
`Set<VBD>` | `VBDs` virtual block devices
`Long` | `VCPUsAtStartup` Boot number of VCPUs
`Long` | `VCPUsMax` Max number of VCPUs
`Map<String,String>` | `VCPUsParams` configuration parameters for the selected VCPU policy
`Long` | `version` The number of times this VM has been recovered
`Set<VGPU>` | `VGPUs` Virtual GPUs
`Set<VIF>` | `VIFs` virtual network interfaces
`Set<VTPM>` | `VTPMs` virtual TPMs
`Map<String,String>` | `xenstoreData` data to be inserted into the xenstore tree (/local/domain//vm-data) after the VM is created.

Constructor Summary
`VM.Record()`

Method Summary
`Map<String,Object>` | `toMap()` Convert a VM.Record to a Map
`String` | `toString()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### uuid

    public String uuid

  Unique identifier/object reference

### allowedOperations

    public Set<Types.VmOperations> allowedOperations

  list of the operations allowed in this state. This list is advisory only and the server state may have changed by the time this field is read by a client.

### currentOperations

    public Map<String,Types.VmOperations> currentOperations

  links each of the running tasks using this object (by reference) to a current_operation enum which describes the nature of the task.

### powerState

    public Types.VmPowerState powerState

  Current power state of the machine

### nameLabel

    public String nameLabel

  a human-readable name

### nameDescription

    public String nameDescription

  a notes field containing human-readable description

### userVersion

    public Long userVersion

  a user version number for this machine

### isATemplate

    public Boolean isATemplate

  true if this is a template. Template VMs can never be started, they are used only for cloning other VMs

### suspendVDI

    public VDI suspendVDI

  The VDI that a suspend image is stored on. (Only has meaning if VM is currently suspended)

### residentOn

    public Host residentOn

  the host the VM is currently resident on

### affinity

    public Host affinity

  a host which the VM has some affinity for (or NULL). This is used as a hint to the start call when it decides where to run the VM. Implementations are free to ignore this field.

### memoryOverhead

    public Long memoryOverhead

  Virtualization memory overhead (bytes).

### memoryTarget

    public Long memoryTarget

  Dynamically-set memory target (bytes). The value of this field indicates the current target for memory available to this VM.

### memoryStaticMax

    public Long memoryStaticMax

  Statically-set (i.e. absolute) maximum (bytes). The value of this field at VM start time acts as a hard limit of the amount of memory a guest can use. New values only take effect on reboot.

### memoryDynamicMax

    public Long memoryDynamicMax

  Dynamic maximum (bytes)

### memoryDynamicMin

    public Long memoryDynamicMin

  Dynamic minimum (bytes)

### memoryStaticMin

    public Long memoryStaticMin

  Statically-set (i.e. absolute) mininum (bytes). The value of this field indicates the least amount of memory this VM can boot with without crashing.

### VCPUsParams

    public Map<String,String> VCPUsParams

  configuration parameters for the selected VCPU policy

### VCPUsMax

    public Long VCPUsMax

  Max number of VCPUs

### VCPUsAtStartup

    public Long VCPUsAtStartup

  Boot number of VCPUs

### actionsAfterShutdown

    public Types.OnNormalExit actionsAfterShutdown

  action to take after the guest has shutdown itself

### actionsAfterReboot

    public Types.OnNormalExit actionsAfterReboot

  action to take after the guest has rebooted itself

### actionsAfterCrash

    public Types.OnCrashBehaviour actionsAfterCrash

  action to take if the guest crashes

### consoles

    public Set<Console> consoles

  virtual console devices

### VIFs

    public Set<VIF> VIFs

  virtual network interfaces

### VBDs

    public Set<VBD> VBDs

  virtual block devices

### crashDumps

    public Set<Crashdump> crashDumps

  crash dumps associated with this VM

### VTPMs

    public Set<VTPM> VTPMs

  virtual TPMs

### PVBootloader

    public String PVBootloader

  name of or path to bootloader

### PVKernel

    public String PVKernel

  path to the kernel

### PVRamdisk

    public String PVRamdisk

  path to the initrd

### PVArgs

    public String PVArgs

  kernel command-line arguments

### PVBootloaderArgs

    public String PVBootloaderArgs

  miscellaneous arguments for the bootloader

### PVLegacyArgs

    public String PVLegacyArgs

  to make Zurich guests boot

### HVMBootPolicy

    public String HVMBootPolicy

  HVM boot policy

### HVMBootParams

    public Map<String,String> HVMBootParams

  HVM boot params

### HVMShadowMultiplier

    public Double HVMShadowMultiplier

  multiplier applied to the amount of shadow that will be made available to the guest

### platform

    public Map<String,String> platform

  platform-specific configuration

### PCIBus

    public String PCIBus

  PCI bus path for pass-through devices

### otherConfig

    public Map<String,String> otherConfig

  additional configuration

### domid

    public Long domid

  domain ID (if available, -1 otherwise)

### domarch

    public String domarch

  Domain architecture (if available, null string otherwise)

### lastBootCPUFlags

    public Map<String,String> lastBootCPUFlags

  describes the CPU flags on which the VM was last booted

### isControlDomain

    public Boolean isControlDomain

  true if this is a control domain (domain 0 or a driver domain)

### metrics

    public VMMetrics metrics

  metrics associated with this VM

### guestMetrics

    public VMGuestMetrics guestMetrics

  metrics associated with the running guest

### lastBootedRecord

    public String lastBootedRecord

  marshalled value containing VM record at time of last boot, updated dynamically to reflect the runtime state of the domain

### recommendations

    public String recommendations

  An XML specification of recommended values and ranges for properties of this VM

### xenstoreData

    public Map<String,String> xenstoreData

  data to be inserted into the xenstore tree (/local/domain//vm-data) after the VM is created.

### haAlwaysRun

    public Boolean haAlwaysRun

  if true then the system will attempt to keep the VM running as much as possible.

### haRestartPriority

    public String haRestartPriority

  has possible values: "best-effort" meaning "try to restart this VM if possible but don't consider the Pool to be overcommitted if this is not possible"; "restart" meaning "this VM should be restarted"; "" meaning "do not try to restart this VM"

### isASnapshot

    public Boolean isASnapshot

  true if this is a snapshot. Snapshotted VMs can never be started, they are used only for cloning other VMs

### snapshotOf

    public VM snapshotOf

  Ref pointing to the VM this snapshot is of.

### snapshots

    public Set<VM> snapshots

  List pointing to all the VM snapshots.

### snapshotTime

    public Date snapshotTime

  Date/time when this snapshot was created.

### transportableSnapshotId

    public String transportableSnapshotId

  Transportable ID of the snapshot VM

### blobs

    public Map<String,Blob> blobs

  Binary blobs associated with this VM

### tags

    public Set<String> tags

  user-specified tags for categorization purposes

### blockedOperations

    public Map<Types.VmOperations,String> blockedOperations

  List of operations which have been explicitly blocked and an error code

### snapshotInfo

    public Map<String,String> snapshotInfo

  Human-readable information concerning this snapshot

### snapshotMetadata

    public String snapshotMetadata

  Encoded information about the VM's metadata this is a snapshot of

### parent

    public VM parent

  Ref pointing to the parent of this VM

### children

    public Set<VM> children

  List pointing to all the children of this VM

### biosStrings

    public Map<String,String> biosStrings

  BIOS strings

### protectionPolicy

    public VMPP protectionPolicy

  Ref pointing to a protection policy for this VM

### isSnapshotFromVmpp

    public Boolean isSnapshotFromVmpp

  true if this snapshot was created by the protection policy

### appliance

    public VMAppliance appliance

  the appliance to which this VM belongs

### startDelay

    public Long startDelay

  The delay to wait before proceeding to the next order in the startup sequence (seconds)

### shutdownDelay

    public Long shutdownDelay

  The delay to wait before proceeding to the next order in the shutdown sequence (seconds)

### order

    public Long order

  The point in the startup or shutdown sequence at which this VM will be started

### VGPUs

    public Set<VGPU> VGPUs

  Virtual GPUs

### attachedPCIs

    public Set<PCI> attachedPCIs

  Currently passed-through PCI devices

### suspendSR

    public SR suspendSR

  The SR on which a suspend image is stored

### version

    public Long version

  The number of times this VM has been recovered

### generationId

    public String generationId

  Generation ID of the VM

Constructor Detail

### VM.Record

    public VM.Record()

Method Detail

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

### toMap

    public Map<String,Object> toMap()

  Convert a VM.Record to a Map

  Specified by:
    `toMap` in interface `Types.Record`

Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD